Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.evpull
Class StaxToEventBridge

    java.lang.Object
      net.sf.saxon.evpull.StaxToEventBridge

All Implemented Interfaces:
  SourceLocator, LocationProvider, SaxonLocator, SourceLocationProvider, EventIterator, PullEvent, Locator

    public class StaxToEventBridge

extends Object
implements EventIterator, SaxonLocator, SourceLocationProvider

This class implements the Saxon EventIterator API on top of a standard StAX parser (or any other StAX XMLStreamReader implementation)

Constructor Summary
`StaxToEventBridge()` Create a new instance of the class

Method Summary
`int` | `getColumnNumber()` Return the column number where the current document event ends.
`int` | `getColumnNumber(long locationId)` Get the column number within the document, entity, or module containing a particular location
`int` | `getLineNumber()` Return the line number where the current document event ends.
`int` | `getLineNumber(long locationId)` Get the line number within the document, entity or module containing a particular location
`NamePool` | `getNamePool()` Get the name pool
`PipelineConfiguration` | `getPipelineConfiguration()` Get configuration information.
`String` | `getPublicId()` Return the public identifier for the current document event.
`String` | `getSystemId()` Return the system identifier for the current document event.
`String` | `getSystemId(long locationId)` Get the URI of the document, entity, or module containing a particular location
`List` | `getUnparsedEntities()` Get a list of unparsed entities.
`XMLStreamReader` | `getXMLStreamReader()` Get the XMLStreamReader used by this StaxBridge.
`boolean` | `isFlatSequence()` Determine whether the EventIterator returns a flat sequence of events, or whether it can return nested event iterators
`static void` | `main(String[] args)` Simple test program Usage: java StaxBridge in.xml [out.xml]
`PullEvent` | `next()` Get the next event
`void` | `setInputStream(String systemId, InputStream inputStream)` Supply an input stream containing XML to be parsed.
`void` | `setPipelineConfiguration(PipelineConfiguration pipe)` Set configuration information.
`void` | `setXMLStreamReader(XMLStreamReader reader)` Supply an XMLStreamReader: the events reported by this XMLStreamReader will be translated into EventIterator events

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### StaxToEventBridge

    public StaxToEventBridge()

  Create a new instance of the class

Method Detail

### setInputStream

    public void setInputStream(String systemId,
                               InputStream inputStream)
                        throws XPathException

  Supply an input stream containing XML to be parsed. A StAX parser is created using the JAXP XMLInputFactory.

  Parameters:
    `systemId` - The Base URI of the input document
    `inputStream` - the stream containing the XML to be parsed
  Throws:
    `XPathException` - if an error occurs creating the StAX parser

### setXMLStreamReader

    public void setXMLStreamReader(XMLStreamReader reader)

  Supply an XMLStreamReader: the events reported by this XMLStreamReader will be translated into EventIterator events

  Parameters:
    `reader` - the supplier of XML events, typically an XML parser

### setPipelineConfiguration

    public void setPipelineConfiguration(PipelineConfiguration pipe)

  Set configuration information. This must only be called before any events have been read.

  Parameters:
    `pipe` - the pipeline configuration

### getPipelineConfiguration

    public PipelineConfiguration getPipelineConfiguration()

  Get configuration information.

  Returns:
    the pipeline configuration

### getXMLStreamReader

    public XMLStreamReader getXMLStreamReader()

  Get the XMLStreamReader used by this StaxBridge. This is available only after setInputStream() or setXMLStreamReader() has been called

  Returns:
    the instance of XMLStreamReader allocated when setInputStream() was called, or the instance supplied directly to setXMLStreamReader()

### getNamePool

    public NamePool getNamePool()

  Get the name pool

  Returns:
    the name pool

### next

    public PullEvent next()
                   throws XPathException

  Get the next event

  Specified by:
    `next` in interface `EventIterator`
  Returns:
    the next event; or null to indicate the end of the event stream
  Throws:
    `XPathException` - if a dynamic evaluation error occurs

### getPublicId

    public String getPublicId()

  Return the public identifier for the current document event.

  The return value is the public identifier of the document entity or of the external parsed entity in which the markup triggering the event appears.

  Specified by:
    `getPublicId` in interface `SourceLocator`
  Specified by:
    `getPublicId` in interface `Locator`
  Returns:
    A string containing the public identifier, or null if none is available.
  See Also:
    `getSystemId()`

### getSystemId

    public String getSystemId()

  Return the system identifier for the current document event.

  The return value is the system identifier of the document entity or of the external parsed entity in which the markup triggering the event appears.

  If the system identifier is a URL, the parser must resolve it fully before passing it to the application. For example, a file name must always be provided as a file:... URL, and other kinds of relative URI are also resolved against their bases.

  Specified by:
    `getSystemId` in interface `SourceLocator`
  Specified by:
    `getSystemId` in interface `Locator`
  Returns:
    A string containing the system identifier, or null if none is available.
  See Also:
    `getPublicId()`

### getLineNumber

    public int getLineNumber()

  Return the line number where the current document event ends. Lines are delimited by line ends, which are defined in the XML specification.

  Warning: The return value from the method is intended only as an approximation for the sake of diagnostics; it is not intended to provide sufficient information to edit the character content of the original XML document. In some cases, these "line" numbers match what would be displayed as columns, and in others they may not match the source text due to internal entity expansion.

  The return value is an approximation of the line number in the document entity or external parsed entity where the markup triggering the event appears.

  If possible, the SAX driver should provide the line position of the first character after the text associated with the document event. The first line is line 1.

  Specified by:
    `getLineNumber` in interface `SourceLocator`
  Specified by:
    `getLineNumber` in interface `Locator`
  Returns:
    The line number, or -1 if none is available.
  See Also:
    `getColumnNumber()`

### getColumnNumber

    public int getColumnNumber()

  Return the column number where the current document event ends. This is one-based number of Java `char` values since the last line end.

  Warning: The return value from the method is intended only as an approximation for the sake of diagnostics; it is not intended to provide sufficient information to edit the character content of the original XML document. For example, when lines contain combining character sequences, wide characters, surrogate pairs, or bi-directional text, the value may not correspond to the column in a text editor's display.

  The return value is an approximation of the column number in the document entity or external parsed entity where the markup triggering the event appears.

  If possible, the SAX driver should provide the line position of the first character after the text associated with the document event. The first column in each line is column 1.

  Specified by:
    `getColumnNumber` in interface `SourceLocator`
  Specified by:
    `getColumnNumber` in interface `Locator`
  Returns:
    The column number, or -1 if none is available.
  See Also:
    `getLineNumber()`

### getSystemId

    public String getSystemId(long locationId)

  Description copied from interface: `LocationProvider`
  Get the URI of the document, entity, or module containing a particular location

  Specified by:
    `getSystemId` in interface `LocationProvider`
  Parameters:
    `locationId` - identifier of the location in question (as passed down the Receiver pipeline)
  Returns:
    the URI of the document, XML entity or module. For a SourceLocationProvider this will be the URI of the document or entity (the URI that would be the base URI if there were no xml:base attributes). In other cases it may identify the query or stylesheet module currently being executed.

### getLineNumber

    public int getLineNumber(long locationId)

  Description copied from interface: `LocationProvider`
  Get the line number within the document, entity or module containing a particular location

  Specified by:
    `getLineNumber` in interface `LocationProvider`
  Parameters:
    `locationId` - identifier of the location in question (as passed down the Receiver pipeline)
  Returns:
    the line number within the document, entity or module, or -1 if no information is available.

### getColumnNumber

    public int getColumnNumber(long locationId)

  Description copied from interface: `LocationProvider`
  Get the column number within the document, entity, or module containing a particular location

  Specified by:
    `getColumnNumber` in interface `LocationProvider`
  Parameters:
    `locationId` - identifier of the location in question (as passed down the Receiver pipeline)
  Returns:
    the column number within the document, entity, or module, or -1 if this is not available

### getUnparsedEntities

    public List getUnparsedEntities()

  Get a list of unparsed entities.

  Returns:
    a list of unparsed entities, or null if the information is not available, or an empty list if there are no unparsed entities. Each item in the list will be an instance of `UnparsedEntity`

### main

    public static void main(String[] args)
                     throws Exception

  Simple test program Usage: java StaxBridge in.xml [out.xml]

  Parameters:
    `args` - command line arguments
  Throws:
    `Exception`

### isFlatSequence

    public boolean isFlatSequence()

  Determine whether the EventIterator returns a flat sequence of events, or whether it can return nested event iterators

  Specified by:
    `isFlatSequence` in interface `EventIterator`
  Returns:
    true if the next() method is guaranteed never to return an EventIterator

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.